require '_h2ph_pre.ph';

unless(defined(&_LINUX_LKST_PRIVATE_H)) {
    eval 'sub _LINUX_LKST_PRIVATE_H () {1;}' unless defined(&_LINUX_LKST_PRIVATE_H);
    unless(defined(&CMD_LKSTDUMP)) {
	require 'linux/sched.ph';
	require 'linux/lkst.ph';
    }
    require 'linux/lkst_maskset.ph';
    require 'linux/lkst_buffer.ph';
    require 'linux/lkst_evhandler.ph';
    unless(defined(&CMD_LKSTDUMP)) {
	require 'linux/kernel_stat.ph';
	require 'linux/string.ph';
    }
    require 'linux/wait.ph';
    require 'linux/cache.ph';
    require 'asm/atomic.ph';
    require 'asm/lkst_private.ph';
    eval 'sub LKST_CPU_RECID_SIZE () { &SMP_CACHE_BYTES/$sizeof{ &lkst_cpu_recid};}' unless defined(&LKST_CPU_RECID_SIZE);
    eval 'sub LKST_CPU_RECID_BUF_SIZE () { &LKST_CPU_MAX* &LKST_CPU_RECID_SIZE;}' unless defined(&LKST_CPU_RECID_BUF_SIZE);
    eval 'sub LKST_BUFFER_SIZE_DEFAULT () {(64*1024);}' unless defined(&LKST_BUFFER_SIZE_DEFAULT);
    eval 'sub LKST_BUFFER_SIZE_MAX () {(64*1024*1024);}' unless defined(&LKST_BUFFER_SIZE_MAX);
    eval 'sub LKST_BUFFER_SIZE_MIN () {8192;}' unless defined(&LKST_BUFFER_SIZE_MIN);
    eval 'sub LKST_BUFFER_HEADSPACE () {($sizeof{\'struct lkst_event_record\'} *  &LKST_CPU_MAX * 2);}' unless defined(&LKST_BUFFER_HEADSPACE);
    eval 'sub LKST_EVHANDLER_BUFFER_TRIAL_MAX () {10;}' unless defined(&LKST_EVHANDLER_BUFFER_TRIAL_MAX);
    eval 'sub LKST_EVHANDLER_MASKSET_TRIAL_MAX () {10;}' unless defined(&LKST_EVHANDLER_MASKSET_TRIAL_MAX);
    eval 'sub LKST_DEV_MAJOR () {231;}' unless defined(&LKST_DEV_MAJOR);
    eval 'sub LKST_DEV_MINOR () {0;}' unless defined(&LKST_DEV_MINOR);
    eval 'sub LKST_DEV_NAME () {"lkst";}' unless defined(&LKST_DEV_NAME);
    eval 'sub LKST_BUF_VER () {0x000100;}' unless defined(&LKST_BUF_VER);
    eval 'sub LKST_FLAG_YES () {1;}' unless defined(&LKST_FLAG_YES);
    eval 'sub LKST_FLAG_NO () {0;}' unless defined(&LKST_FLAG_NO);
    if(defined(&CONFIG_DEBUG_KERNEL_STATE_TRACE_MODULE)) {
    }
    unless(defined(&CMD_LKSTDUMP)) {
	if((defined(&DEBUG) ? &DEBUG : 0)) {
	}
    }
    eval 'sub LKST_BUFFER_BODY_INDEX {
        local($buffer,$index) = @_;
	    eval q((((($buffer))-> $body[($index)])));
    }' unless defined(&LKST_BUFFER_BODY_INDEX);
    eval 'sub LKST_BUFFER_BODY_TOP {
        local($buffer) = @_;
	    eval q(( &LKST_BUFFER_BODY_INDEX(($buffer),0)));
    }' unless defined(&LKST_BUFFER_BODY_TOP);
    eval 'sub LKST_BUFFER_BODY_OFFSET () {
        eval q(( &LKST_BUFFER_BODY_TOP( &NULL)));
    }' unless defined(&LKST_BUFFER_BODY_OFFSET);
    eval 'sub LKST_BUFFER_AREA_SIZE {
        local($n) = @_;
	    eval q(( &LKST_BUFFER_BODY_OFFSET() + ($n)));
    }' unless defined(&LKST_BUFFER_AREA_SIZE);
    if(defined(&LKST_DEBUG_PRINTK)) {
	eval 'sub DPRINTK () {( &fmt,  &args...)  &printk( &KERN_ERR "LKST(%s): "  &fmt,  &__FUNCTION__,   &args);}' unless defined(&DPRINTK);
    } else {
	eval 'sub DPRINTK () {( &fmt,  &args...);}' unless defined(&DPRINTK);
    }
    unless(defined(&CMD_LKSTDUMP)) {
	if(defined(&CONFIG_MODULES)) {
	}
	if(defined(&CONFIG_MODULES)) {
	}
    }
    eval 'sub LKST_ETYPE_VERIFY {
        local($event_type) = @_;
	    eval q((!(0xfffff000($event_type))));
    }' unless defined(&LKST_ETYPE_VERIFY);
    eval 'sub LKST_POINTER_CHECK_VAL {
        local($p) = @_;
	    eval q(( &LKST_POINTER_CHECK_MAGIC - (($p))));
    }' unless defined(&LKST_POINTER_CHECK_VAL);
    eval 'sub LKST_POINTER_CHECK_INIT {
        local($p) = @_;
	    eval q(($p &_check =  &LKST_POINTER_CHECK_VAL($p)));
    }' unless defined(&LKST_POINTER_CHECK_INIT);
    eval 'sub LKST_POINTER_INVALIDATE {
        local($p) = @_;
	    eval q(($p &_check = , ($p) =  &NULL ));
    }' unless defined(&LKST_POINTER_INVALIDATE);
    eval 'sub LKST_POINTER_VERIFY_STRICT {
        local($p1, $p2) = @_;
	    eval q(( = , ($p1 &_check) ==  &LKST_POINTER_CHECK_VAL(($p2))));
    }' unless defined(&LKST_POINTER_VERIFY_STRICT);
    eval 'sub LKST_POINTER_VERIFY {
        local($p1, $p2) = @_;
	    eval q( &LKST_POINTER_VERIFY_STRICT($p1, $p2));
    }' unless defined(&LKST_POINTER_VERIFY);
    eval 'sub LKST_POINTER_VERIFY_HP {
        local($p1, $p2) = @_;
	    eval q((($p2) = ($p1), 1));
    }' unless defined(&LKST_POINTER_VERIFY_HP);
    eval 'sub LKST_MASKSET_QUERY_EVHANDLER_ID {
        local($maskset_ptr, $event_type) = @_;
	    eval q(((($maskset_ptr))[($event_type)]));
    }' unless defined(&LKST_MASKSET_QUERY_EVHANDLER_ID);
    eval 'sub LKST_MASKSET_SET_EVHANDLER_ID {
        local($maskset_ptr, $event_type, $id) = @_;
	    eval q(((($maskset_ptr))[($event_type)] = ($id)));
    }' unless defined(&LKST_MASKSET_SET_EVHANDLER_ID);
    eval 'sub LKST_MASKSET_TABLE_ENTRY_SET {
        local($table, $id, $maskname, $addr) = @_;
	    eval q(({ []. &masksetp = ;  &strncpy([]. &name, ,  &LKST_MASKSET_NAME_LEN); ($table)[$id]. $name[ &LKST_MASKSET_NAME_LEN-1] = ord(\'\\\\0\');  &LKST_POINTER_CHECK_INIT(($table)[($id)]. &masksetp); }));
    }' unless defined(&LKST_MASKSET_TABLE_ENTRY_SET);
    eval 'sub LKST_MASKSET_SET_CURRENT {
        local($id) = @_;
	    eval q(({  ($lkst->{current_maskset_id}) = ($id);  ($lkst->{current_masksetp}) =  ($lkst->{maskset_table[&(id)]}->{masksetp});  &LKST_POINTER_CHECK_INIT( ($lkst->{current_masksetp}));}));
    }' unless defined(&LKST_MASKSET_SET_CURRENT);
    eval 'sub LKST_BUFFER_PREV_ENTRY {
        local($buffer, $pt, $size) = @_;
	    eval q(( ( ($buffer) + ((($pt) - $sizeof{\'struct lkst_event_record\'}) & ($size - 1)))));
    }' unless defined(&LKST_BUFFER_PREV_ENTRY);
    eval 'sub LKST_BUFFER_READP_RESET {
        local($buffer) = @_;
	    eval q(({ -> &readp =  &LKST_BUFFER_HEADSPACE; -> &last_readp = (-> &readp -  &sizeof) & (-> &size - 1); -> &last_recid = ( ( (($buffer)-> &body) + ($buffer)-> &last_readp))-> &log_recid;}));
    }' unless defined(&LKST_BUFFER_READP_RESET);
}
1;
